'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var preact = require('preact');
var slugify = _interopDefault(require('slugify'));

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function Button(_ref) {
  var title = _ref.title,
      url = _ref.url,
      external = _ref.external,
      theme = _ref.theme,
      ga_prefix = _ref.ga_prefix,
      classes = _ref.classes,
      additionalProps = _objectWithoutProperties(_ref, ['title', 'url', 'external', 'theme', 'ga_prefix', 'classes']);

  if (theme && (typeof theme === 'undefined' ? 'undefined' : _typeof(theme)) === 'object') theme = theme.slug;
  var gaSlug = slugify(title, { lower: true });
  var ext = external === 'true' || external === true;
  return preact.h(
    'a',
    _extends({
      'class': 'g-btn' + (theme ? ' ' + theme : '') + (classes ? ' ' + classes : ''),
      'data-ga-button': '' + (ga_prefix ? ga_prefix + ' | ' : '') + gaSlug
    }, url && { href: url }, ext && { rel: 'noopener', target: '_blank' }, additionalProps),
    title
  );
}

module.exports = Button;
